# Enum rustc_codegen_ssa::back::write::Message

source ·

    pub(crate) enum Message<B: WriteBackendMethods> {
        Token(Result<Acquired>),
        WorkItem {
            result: Result<WorkItemResult<B>, Option<WorkerFatalError>>,
            worker_id: usize,
        },
        CodegenDone {
            llvm_work_item: WorkItem<B>,
            cost: u64,
        },
        AddImportOnlyModule {
            module_data: SerializedModule<B::ModuleBuffer>,
            work_product: WorkProduct,
        },
        CodegenComplete,
        CodegenAborted,
    }

Expand description

Messages sent to the coordinator.

## Variants§

§

### Token(Result<Acquired>)

A jobserver token has become available. Sent from the jobserver helper thread.

§

### WorkItem

#### Fields

§`result: Result<WorkItemResult<B>, Option<WorkerFatalError>>`
§`worker_id: usize`

The backend has finished processing a work item for a codegen unit. Sent from a backend worker thread.

§

### CodegenDone

#### Fields

§`llvm_work_item: WorkItem<B>`
§`cost: u64`

The frontend has finished generating something (backend IR or a post-LTO artifact) for a codegen unit, and it should be passed to the backend. Sent from the main thread.

§

### AddImportOnlyModule

#### Fields

§`module_data: SerializedModule<B::ModuleBuffer>`
§`work_product: WorkProduct`

Similar to `CodegenDone`, but for reusing a pre-LTO artifact Sent from the main thread.

§

### CodegenComplete

The frontend has finished generating everything for all codegen units. Sent from the main thread.

§

### CodegenAborted

Some normal-ish compiler error occurred, and codegen should be wound down. Sent from the main thread.

## Auto Trait Implementations§

§

### impl<B> !RefUnwindSafe for Message<B>

§

### impl<B> Send for Message<B>

§

### impl<B> Sync for Message<B>

§

### impl<B> Unpin for Message<B>
where <B as WriteBackendMethods>::Module: Unpin, <B as WriteBackendMethods>::ModuleBuffer: Unpin, <B as WriteBackendMethods>::ThinBuffer: Unpin,

§

### impl<B> !UnwindSafe for Message<B>

## Blanket Implementations§

source§

### impl<T> Any for T
where T: 'static + ?Sized,

source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
source§

### impl<T> Borrow<T> for T
where T: ?Sized,

source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
source§

### impl<T> From<T> for T

source§

#### fn from(t: T) -> T

Returns the argument unchanged.

source§

### impl<T, U> Into<U> for T
where U: From<T>,

source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

§

#### type Error = Infallible

The type returned in the event of a conversion error.
source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.

## Layout§

Note: Unable to compute type layout, possibly due to this type having generic parameters. Layout can only be computed for concrete, fully-instantiated types.